#include<reg52.h> //including sfr registers for ports of the controller
 
//LCD Module Connections
sbit rs = P2^0;
sbit rw = P2^1;
sbit en = P2^2;
sbit sda=P2^3;
sbit scl=P2^4; 
  #define dataport P1        // Data port for LCD
//End LCD Module Connections
 
//Keypad Connections
sbit R1 = P3^0;
sbit R2 = P3^1;
sbit R3 = P3^2;
sbit R4 = P3^3;
sbit C1 = P3^4;
sbit C2 = P3^5;
sbit C3 = P3^6;
sbit C4 = P3^7;
//End Keypad Connections
 
 
void Delay(unsigned char);  
void lcd_command(unsigned char);   //LCD command funtion
void lcd_data(unsigned char);  //LCD data function 
void lcd_ini(void);               
void lcd_string(unsigned char *);    //LCD string function 
void set_key(unsigned int,unsigned int,unsigned int);
char Read_Keypad(void);

 void EE_init()
{
 //initialize EEPROM
 unsigned char i;
sda = 1;
for (i=0; i<10; i++)
{
scl = 1;
i=i; //Delay 
scl = 0;
}
}
//Start
void EE_strt()
 { 
sda = 1; 
scl = 1; 
sda = 0; 
scl = 0; 
} 
//Stop 
void EE_stop() 
{ 
scl = 0; 
sda = 0; 
scl = 1; 
sda = 1; 
} 
//Shift out
void EE_shout(char sho) 
{
unsigned char i,j;
for (j=0, i=0; i<8; i++) {
j /= 2;
if (!j)
j=128;
if (sho&j)
CY =1;
else
CY = 0;
sda = CY;
scl = 1;
j = j; //Delay
scl = 0;
}
sda = 1;
scl = 1;
j=j; //Delay
CY = sda;
scl = 0;
}
//Shift in
char EE_shin() 
{
char i,shi = 0;
sda = 1;
for (i=0; i<8; i++) {
CY =0;
shi <<= 1; 
scl = 1; 
i=i; 
CY = sda; 
scl = 0; 
if (CY)
shi++;
}
sda = 1;
scl = 1;
i=i; //Delay
scl = 0;
return shi;
}
void ee_write(unsigned int addr, int dta)
{
char chtmp;
CY = 0;
EE_strt();
EE_shout(0xA0);
chtmp = addr>>8;
EE_shout(chtmp);
chtmp = addr;
EE_shout(chtmp); 
EE_shout(dta); 
EE_stop(); 
Delay(13); 
}
//Reading from EEPROM 
char ee_read (unsigned int addr) 
{ 
char chtmp; 
CY = 0; 
EE_strt(); 
EE_shout(0xA0); 
chtmp = addr>>8; 
EE_shout(chtmp); 
chtmp = addr; 
EE_shout(chtmp); 
EE_strt(); 
EE_shout(0xA1); 
chtmp = EE_shin(); 
EE_stop(); 
return chtmp; 
}

 
void main()
{
   unsigned int c = 0, p = 0,pos = -1,i = 0,j=0;
    unsigned long int time;
   lcd_ini();
   EE_init(); 
   
  while(1)
  {
 
   p = c;   
   time=25000;
    //while(!(c = Read_Keypad()) &&  time--); 		 	 
    while( ( !(c = Read_Keypad()) ) &&  time--);
//	if (time == 0)	
//	pos++;	
    if(p == c && c != 14 && c != 15)
    {
	  	if(pos>15)
		{
		j=pos-16;
		 
		 lcd_command(0xC0+j);  
		}
		else
		{
	 	lcd_command(0x80+pos); 
		}
        set_key(c,i,pos);
		  if(++i >= 3)
        i=0; 
    }
    else if(c == 14)
    {
    pos--;
	if(pos>15)
		{
		 j=pos-16;
		 lcd_command(0xC0+j);  
		}
		else
		{
	 	lcd_command(0x80+pos); 
		}
    set_key(c,i,pos);
    i = 0;
    }
	else if(c == 15)
    {
    pos++;
	if(pos>15)
		{
		 j=pos-16;
		 lcd_command(0xC0+j);  
		}
		else
		{
	 	lcd_command(0x80+pos); 
		}
    set_key(c,i,pos);
    i = 0;
    }
    else
    {
       i = 0;
	    pos++;
	    if(pos>15)
		{
		 j=pos-16;
		 lcd_command(0xC0+j);  
		}
		else
		{
	 	lcd_command(0x80+pos); 
		}
	  }
	}
  }
 
void set_key(unsigned int c,unsigned int i, unsigned int pos)
{
   unsigned int t=0;     

    if(c>9 && c<13  )
	 {
	  	//lcd_command(0x80 + pos); 	 	  
	   t='0'+ (c-10)*3 + i ;
       ee_write(pos,t);
	   lcd_data(ee_read(pos));	
    }
	 else if(c==13)
	 {
	   if(i==0)
	    t='9' ;	
      	else if(i==1)
	    t='.' ;	
		else if(i==2)
	    t='-' ;	
      ee_write(pos,t);
	  lcd_data(ee_read(pos));
	  }	   
	 else if(c==14)
	 {
	 	//lcd_command(0x80 + pos); 
       t=' ';
	   ee_write(pos,t);
	  lcd_data(ee_read(pos));
      }	  
	  else if(c==15)
	 {
	  //lcd_command(0x80+pos); 	  	
       t= ' ';
      ee_write(pos,t);
	  lcd_data(ee_read(pos));
	  }	 
	 else if(c==16)
	 {
	   if(i==0)
	    t='-' ;	
      	else if(i==1)
	    t='=' ;	
		else if(i==2)
	    t='#' ;	
      ee_write(pos,t);
	  lcd_data(ee_read(pos));
	  }	   
	 else
	 {	   
	   //lcd_command(0x80 + pos);     	   
       t= 'A' + (c-1)*3 + i ;	  	   
      ee_write(pos,t);
	  lcd_data(ee_read(pos));
	}
    Delay(10);       
}
 
void Delay(unsigned char msDelay)   
{
    unsigned int j;
    unsigned char i;
    for(i=0;i<msDelay;i++)
    for(j=0;j<1275;j++);
}
 
void lcd_command(unsigned char comm)   //LCD command funtion
{
    dataport=comm;
    en=1;
    rs=0;
    rw=0;
    Delay(1);
    en=0;
}
 
void lcd_data(unsigned char disp)  //LCD data function 
{
    dataport=disp;
    en=1;
    rs=1;
    rw=0;
    Delay(1);
    en=0;
}
 
void lcd_ini()                
{
    lcd_command(0x38);      
    Delay(5);
    lcd_command(0x0F);        
        lcd_command(0x0E);      
    Delay(5);
    lcd_command(0x01);        
    Delay(5);
    
}
 
 
void lcd_string(unsigned char *disp)     //LCD string function 
{
    char x;
    for(x=0;disp[x]!=0;x++)
    {
        lcd_data(disp[x]);
    }
    
}
 
 
char Read_Keypad(void)
{
 
  C1 = 1;  C2 = 1;  C3 = 1;  C4 = 1;
  R1 = 0;  R2 = 0;  R3 = 0;  R4 = 0;
  if( C1 && C2 && C3 && C4 )
  return 0;
  
  R1=0;
  R2=1;
  R3=1;
  R4=1; 
  if(C1==0){Delay(10);while(C1==0);return 1;}
  if(C2==0){Delay(10);while(C2==0);return 2;}
  if(C3==0){Delay(10);while(C3==0);return 3;}
  if(C4==0){Delay(10);while(C4==0);return 4;}
  R1=1;
  R2=0;
  R3=1;
  R4=1;
  if(C1==0){Delay(10);while(C1==0);return 5;}
  if(C2==0){Delay(10);while(C2==0);return 6;}
  if(C3==0){Delay(10);while(C3==0);return 7;}
  if(C4==0){Delay(10);while(C4==0);return 8;}
  R1=1;
  R2=1;
  R3=0;
  R4=1;
  if(C1==0){Delay(10);while(C1==0);return 9;}
  if(C2==0){Delay(10);while(C2==0);return 10;}
  if(C3==0){Delay(10);while(C3==0);return 11;}
  if(C4==0){Delay(10);while(C4==0);return 12;}
  R1=1;
  R2=1;
  R3=1;
  R4=0;
  if(C1==0){Delay(10);while(C1==0);return 13;}
  if(C2==0){Delay(10);while(C2==0);return 14;}
  if(C3==0){Delay(10);while(C3==0);return 15;}
  if(C4==0){Delay(10);while(C4==0);return 16;}
  return 0;
}

